﻿@model GoC.AppStatus.WebClient.Models.EnvironmentModel

@using GoC.AppStatus.WebClient.Models;

<link rel="stylesheet" type="text/css" href="@Url.Content("~/Static/Styles/myStyle.css")" />

<div class="row">
    <div class="col-md-2">
        <button id="createBtn" style="margin-top: 32px;" class="btn btn-default">@Localizer["Create"]</button>
    </div>
    <div class="col-md-10">
        <div id="envPanel" class="wb-frmvld" style="@(Context.Request.Method == "POST" ? "display:block" : "display:none")">
            <form role="form" action="Create" method="post">
                @if (!ViewData.ModelState.IsValid)
                {
                    <script>
                        var element = document.getElementById("envPanel");
                        element.classList.remove("wb-frmvld");
                    </script>
                    <partial name="_InvalidModelState" />
                }
                <div class="row form-group env-title-margin">
                    <h3>@Localizer["Environment"]</h3>
                    <hr />
                </div>
                <partial name="_Details" model="Model" />
                <div class="row form-group">
                    <div class="col-md-11">
                        <button type="button" id="closePanelBtn" class="btn btn-default pull-right">@Localizer["Cancel"]</button>
                        <button type="submit" class="btn btn-primary display-inline pull-right save-btn-margin">@Localizer["Save"]</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

<div class="env-list-margin">
    @if (ViewData["Environments"] != null)
        // list all existing environments:
        foreach (var environment in (List<EnvironmentModel>)ViewData["Environments"])
        {
            <div id="div_@environment.Id" class="row">
                <div class="col-md-1">
                    <div class="circle circle-padding-left" style="background: #@environment.Colour;">@environment.Title</div>
                </div>
                <div class="col-md-1">
                    <a class="btn btn-default"
                       type="button"
                       asp-action="Edit"
                       asp-route-id="@environment.Id.ToString()"
                       asp-controller="Environments">
                        @Localizer["Edit"]
                    </a>
                </div>
                <div class="col-md-1">
                    <button value="@environment.Id,@environment.Title" class="btn btn-default remove">@Localizer["Remove"]</button>
                </div>
                <br /><br />
            </div>
        }
</div>

@* Modal for confirmation of removing environment *@
<section id="removeEnvConfirmation"
         class="mfp-hide modal-dialog modal-content overlay-def">
    <div class="modal-body">
        <p id="removeEnvConfirmationMsg"></p>
        <button id="btnRemoveEnvConfirmation" class="btn btn-default popup-modal-dismiss" onclick="RemoveEnv(this.val);">
            @Localizer["Yes"]
        </button>
        <button class="btn btn-default popup-modal-dismiss">
            @Localizer["No"]
        </button>
    </div>
</section>

@* Modal for result of removing environment (success or error) *@
<section id="removedEnvironment"
         class="mfp-hide modal-dialog modal-content overlay-def">
    <div id="divRemovedEnvironment" class="modal-body">
    </div>
</section>

@section CustomScripts {
    <script>
        $("#closePanelBtn").click(function () {
            $("#envPanel").hide();
        });

        $("#createBtn").click(function () {
            $("#envPanel").show();
        });

        // Ajax call to remove environment (confirmation required):
        $(".remove").on('click', function () {
            var array = $(this).val().split(',');
            var id = array[0];
            var title = array[1];
            var msg = '@Localizer["Are you sure you want to delete the environment entitled"]' + ' "' + title + '"?<br /><br />';
            msg += '@Localizer["Warning: this action can not be undone!"]' + '<br /><br />';
            document.getElementById("removeEnvConfirmationMsg").innerHTML = msg;
            document.getElementById("btnRemoveEnvConfirmation").val = id;
            $(document).trigger("open.wb-lbx", [[{ src: "#removeEnvConfirmation", type: "inline" }]]);
            return;
        });

        // Ajax call to remove environment (after user has confirmed removing):
        function RemoveEnv(id) {
            var data = { "id": id };
            $.ajax({
                url: "/Environments/Remove",
                data: data,
                success: function (errorMsg) {
                    if (errorMsg == '') {
                        document.getElementById('div_' + id).style.display = "none";
                        msg = '@Localizer["Environment has been removed."]';
                    }
                    else {
                        msg = errorMsg;
                    }
                    document.getElementById("divRemovedEnvironment").innerHTML = msg;
                    $(document).trigger("open.wb-lbx", [[{ src: "#removedEnvironment", type: "inline" }]]);
                }
            });
        }
    </script>
}